unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, TeCanvas, Chart, JclDebug, JclHookExcept;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FMinimized: Boolean;
    procedure LogException(ExceptObj: Tobject; ExceptAddr: Pointer; OSException: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  UserAppDataPath: String;

implementation

{$R *.dfm}

uses
  Math,  uThreadLog;

const

  MaxLogFileSize = 10 * 1024 * 1024; //      
  MaxLogFilesNmb = 10; //  

procedure TForm1.LogException(ExceptObj: Tobject; ExceptAddr: Pointer; OSException: Boolean);
var Log: TStringList;
begin
  if (ExceptObj is Exception) and
     Not(ExceptObj is EAbort) then
  begin
    Log := TStringList.Create;
    try
      JclLastExceptStackListToStrings(Log,
                                      True,    //    
                                      True,    //       
                                      True);   //              ,     .


        Log.Insert(0,'=========================================================================================');
        Log.Insert(0,Exception(ExceptObj).Message + ' ' + FormatDateTime('dd/mm/yyyy hh:mm:ss:ms',Now));
        Log.Insert(0,'');
        ThrLog.Add(Log);
        ThrLog.Add('');
        ThrLog.Add('=========================================================================================');
    finally
      Log.Free;
    end;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  //       -
  ThrLog := TThreadLog.Create(ExtractFilePath(Application.ExeName)+'Log.txt',MaxLogFileSize,MaxLogFilesNmb,True);
  Sleep(1000);
  ThrLog.Add(''); ThrLog.Add('');
  ThrLog.Add('::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::');
  ThrLog.Add('---------- Start ' + FormatDateTime('dd/mm/yyyy hh:mm:ss:ms',Now) + ' -----------');
  ThrLog.Add('::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::');

  JclAddExceptNotifier(LogException, npFirstChain);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ThrLog.Add(''); ThrLog.Add('');
  ThrLog.Add('::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::');
  ThrLog.Add('---------- Stop ' + FormatDateTime('dd/mm/yyyy hh:mm:ss:ms',Now) + ' -----------');
  ThrLog.Add('::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::');

  Sleep(1000);
 JclRemoveExceptNotifier(LogException);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  i: Integer;
begin
  if FMinimized then
  begin
    Series1.Clear;
    for i := 9999 downto 0 do
      Series1.AddXY(Now - i, RandG(0, 50));
    Application.Restore;
    Application.BringToFront;
  end
  else
    Application.Minimize;
  FMinimized:=not FMinimized;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  Chart1.Refresh;
end;

initialization
  UserAppDataPath := ''; //     

  Include(JclStackTrackingOptions, stRawMode);
  JclStartExceptionTracking;
end.
